<?php
class ControllerExtensionModuleCustomMenu extends Controller { 
	private $error = array();

	public function index() {
		$this->language->load('extension/module/custom_menu');

		$this->document->setTitle(strip_tags($this->language->get('heading_title')));
		 
		$this->load->model('module/custom_menu');

		$this->getList();
	}

	public function insert() {
		$this->language->load('extension/module/custom_menu');

		$this->document->setTitle(strip_tags($this->language->get('heading_title')));
		
		$this->load->model('module/custom_menu');
				
		if (($this->request->server['REQUEST_METHOD'] == 'POST') && $this->validateForm()) {
			$this->model_module_custom_menu->addCustomMenu($this->request->post);
			
			$this->session->data['success'] = $this->language->get('text_success');

			$url = '';
			
			if (isset($this->request->get['sort'])) {
				$url .= '&sort=' . $this->request->get['sort'];
			}

			if (isset($this->request->get['order'])) {
				$url .= '&order=' . $this->request->get['order'];
			}

			if (isset($this->request->get['page'])) {
				$url .= '&page=' . $this->request->get['page'];
			}
			
			if (isset($this->request->get['module_id'])) {
				$this->response->redirect($this->url->link('extension/module/custom_menu', 'token=' . $this->session->data['token'] . '&module_id=' . $this->request->get['module_id'], 'SSL'));
			} else {
				$this->response->redirect($this->url->link('extension/module/custom_menu', 'token=' . $this->session->data['token'] . $url, 'SSL'));
			}
		}

		$this->getForm();
	}

	public function update() {
		$this->language->load('extension/module/custom_menu');

		$this->document->setTitle(strip_tags($this->language->get('heading_title')));
		
		$this->load->model('module/custom_menu');
		
		if (($this->request->server['REQUEST_METHOD'] == 'POST') && $this->validateForm()) {
			$this->model_module_custom_menu->editCustomMenu($this->request->get['menu_id'], $this->request->post);
			
			$this->session->data['success'] = $this->language->get('text_success');

			$url = '';
			
			if (isset($this->request->get['sort'])) {
				$url .= '&sort=' . $this->request->get['sort'];
			}

			if (isset($this->request->get['order'])) {
				$url .= '&order=' . $this->request->get['order'];
			}

			if (isset($this->request->get['page'])) {
				$url .= '&page=' . $this->request->get['page'];
			}
			
			if (isset($this->request->get['module_id'])) {
				$this->response->redirect($this->url->link('extension/module/custom_menu', 'token=' . $this->session->data['token'] . '&module_id=' . $this->request->get['module_id'], 'SSL'));
			} else {
				$this->response->redirect($this->url->link('extension/module/custom_menu', 'token=' . $this->session->data['token'] . $url, 'SSL'));
			}
		}

		$this->getForm();
	}
 
	public function delete() {
		$this->language->load('extension/module/custom_menu');

		$this->document->setTitle(strip_tags($this->language->get('heading_title')));
		
		$this->load->model('module/custom_menu');
		
		if (isset($this->request->post['selected']) && $this->validateDelete()) {
			foreach ($this->request->post['selected'] as $menu_id) {
				$this->model_module_custom_menu->deleteCustomMenu($menu_id);
			}
			
			$this->session->data['success'] = $this->language->get('text_success');

			$url = '';
			
			if (isset($this->request->get['sort'])) {
				$url .= '&sort=' . $this->request->get['sort'];
			}

			if (isset($this->request->get['order'])) {
				$url .= '&order=' . $this->request->get['order'];
			}

			if (isset($this->request->get['page'])) {
				$url .= '&page=' . $this->request->get['page'];
			}
			
			$this->response->redirect($this->url->link('extension/module/custom_menu', 'token=' . $this->session->data['token'] . $url, 'SSL'));
		}

		$this->getList();
	}

	protected function getList() {
		
		$this->load->model('setting/setting');
		$this->load->model('extension/module');
				
		if (($this->request->server['REQUEST_METHOD'] == 'POST')) {
			
			//$this->model_setting_setting->editSetting('custom_menu', $this->request->post);
		
			if($this->request->post['status'] != 0) {
				if (!isset($this->request->get['module_id'])) {
					$this->model_extension_module->addModule('custom_menu', $this->request->post);
				} else {
					$this->model_extension_module->editModule($this->request->get['module_id'], $this->request->post);
				}
			}
			
			$this->session->data['success'] = $this->language->get('text_success');
			
			if (VERSION >= 2.2) {
				$this->response->redirect($this->url->link('extension/extension', 'token=' . $this->session->data['token'] . '&type=module', true));
			} else {
				$this->response->redirect($this->url->link('extension/module', 'token=' . $this->session->data['token'], 'SSL'));
			}
		}
		
		$this->load->model('localisation/language');
		
		$data['languages'] = $this->model_localisation_language->getLanguages();
	
		if (isset($this->request->get['sort'])) {
			$sort = $this->request->get['sort'];
		} else {
			$sort = 'id.name';
		}
		
		if (isset($this->request->get['order'])) {
			$order = $this->request->get['order'];
		} else {
			$order = 'ASC';
		}
		
		if (isset($this->request->get['page'])) {
			$page = $this->request->get['page'];
		} else {
			$page = 1;
		}
		
		$url = '';
			
		if (isset($this->request->get['sort'])) {
			$url .= '&sort=' . $this->request->get['sort'];
		}

		if (isset($this->request->get['order'])) {
			$url .= '&order=' . $this->request->get['order'];
		}
		
		if (isset($this->request->get['page'])) {
			$url .= '&page=' . $this->request->get['page'];
		}

  		$data['breadcrumbs'] = array();

   		$data['breadcrumbs'][] = array(
       		'text'      => $this->language->get('text_home'),
			'href'      => $this->url->link('common/home', 'token=' . $this->session->data['token'], 'SSL')
   		);
		
		if(VERSION >= 2.2) {
			$data['breadcrumbs'][] = array(
				'text'      => $this->language->get('text_module'),
				'href'      => $this->url->link('extension/extension', 'token='.$this->session->data['token'].'&type=module', true)
			);
		} else {
			$data['breadcrumbs'][] = array(
				'text'      => $this->language->get('text_module'),
				'href'      => $this->url->link('extension/module', 'token='.$this->session->data['token'], 'SSL')
			);
		}

   		$data['breadcrumbs'][] = array(
       		'text'      => $this->language->get('heading_title'),
			'href'      => $this->url->link('extension/module/custom_menu', 'token=' . $this->session->data['token'] . $url, 'SSL')
   		);
		
		$data['entry_head'] = $this->language->get('entry_head');
		
		$data['text_enabled'] = $this->language->get('text_enabled');
		$data['text_disabled'] = $this->language->get('text_disabled');
		$data['text_style_template'] = $this->language->get('text_style_template');
		$data['text_style_module'] = $this->language->get('text_style_module');
		$data['text_content_top'] = $this->language->get('text_content_top');
		$data['text_content_bottom'] = $this->language->get('text_content_bottom');		
		$data['text_column_left'] = $this->language->get('text_column_left');
		$data['text_column_right'] = $this->language->get('text_column_right');
		$data['entry_style'] = $this->language->get('entry_style');
		$data['entry_layout'] = $this->language->get('entry_layout');
		$data['text_no_results'] = $this->language->get('text_no_results');
		$data['entry_status'] = $this->language->get('entry_status');
		$data['text_status'] = $this->language->get('text_status');
		$data['entry_sort_order'] = $this->language->get('entry_sort_order');
		$data['button_apply'] = $this->language->get('button_apply');
		$data['button_save'] = $this->language->get('button_save');
		$data['button_cancel'] = $this->language->get('button_cancel');
		$data['button_add_module'] = $this->language->get('button_add_module');
		$data['button_remove'] = $this->language->get('button_remove');
		$data['text_select_all'] = $this->language->get('text_select_all');
		$data['text_unselect_all'] = $this->language->get('text_unselect_all');
		
		if (!isset($this->request->get['module_id'])) {
			$data['action_mod'] = $this->url->link('extension/module/custom_menu', 'token=' . $this->session->data['token'], 'SSL');
		} else {
			$data['action_mod'] = $this->url->link('extension/module/custom_menu', 'token=' . $this->session->data['token'] . '&module_id=' . $this->request->get['module_id'], 'SSL');
		}

		if(VERSION >= 2.2) {
			$data['cancel_mod'] = $this->url->link('extension/extension', 'token='.$this->session->data['token'].'&type=module', true);
		} else {
			$data['cancel_mod'] = $this->url->link('extension/module', 'token=' . $this->session->data['token'], 'SSL');
		}
							
		$data['insert'] = $this->url->link('extension/module/custom_menu/insert', 'token=' . $this->session->data['token'] . $url, 'SSL');
		$data['delete'] = $this->url->link('extension/module/custom_menu/delete', 'token=' . $this->session->data['token'] . $url, 'SSL');

		if (isset($this->request->get['module_id'])) {
			$data['module_id'] = $this->request->get['module_id'];
		} else {
			$data['module_id'] = '';
		}

		$data['custom_menus'] = array();

		$filter_data = array(
			'sort'  => $sort,
			'order' => $order,
			'start' => ($page - 1) * $this->config->get('config_limit_admin'),
			'limit' => $this->config->get('config_limit_admin')
		);
		
		$headermenu_total = $this->model_module_custom_menu->getTotalCustomMenu();
	
		$results = $this->model_module_custom_menu->getCustomMenu($filter_data);
 
    	foreach ($results as $result) {
			$action = array();
						
			$action[] = array(
				'text' => $this->language->get('text_edit'),
				'href' => $this->url->link('extension/module/custom_menu/update', 'token=' . $this->session->data['token'] . '&menu_id=' . $result['menu_id'] . $url, 'SSL')
			);
						
			$data['custom_menus'][] = array(
				'menu_id' => $result['menu_id'],
				'name'          => $result['name'],
				'parent_id'          => $result['parent_id'],
				'link'          => $result['link'],
				'sort_order'          => $result['sort_order'],
				'status'          => $result['status'],
				'selected'       => isset($this->request->post['selected']) && in_array($result['menu_id'], $this->request->post['selected']),
				'action'         => $action
			);
		}	
		
		$data['custom_menus1'] = array();		
	
		$results = $this->model_module_custom_menu->getCustomMenu2();
 
    	foreach ($results as $result) {
						
			$data['custom_menus1'][] = array(
				'menu_id' => $result['menu_id'],
				'name'          => $result['name'],
				'parent_id'          => $result['parent_id'],
				'sort_order'          => $result['sort_order'],
			);
		}
		
		$data['lang'] = array_merge($data, $this->language->load('extension/module/custom_menu'));	
		
		$data['button_insert'] = $this->language->get('button_insert');
		$data['button_delete'] = $this->language->get('button_delete');
 
 		if (isset($this->error['warning'])) {
			$data['error_warning'] = $this->error['warning'];
		} else {
			$data['error_warning'] = '';
		}
		
		if (isset($this->session->data['success'])) {
			$data['success'] = $this->session->data['success'];
		
			unset($this->session->data['success']);
		} else {
			$data['success'] = '';
		}

		$url = '';

		if ($order == 'ASC') {
			$url .= '&order=DESC';
		} else {
			$url .= '&order=ASC';
		}

		if (isset($this->request->get['page'])) {
			$url .= '&page=' . $this->request->get['page'];
		}
		
		$data['sort_title'] = $this->url->link('extension/module/custom_menu', 'token=' . $this->session->data['token'] . '&sort=id.name' . $url, 'SSL');
		$data['sort_sort_order'] = $this->url->link('extension/module/custom_menu', 'token=' . $this->session->data['token'] . '&sort=i.sort_order' . $url, 'SSL');
		
		$url = '';

		if (isset($this->request->get['sort'])) {
			$url .= '&sort=' . $this->request->get['sort'];
		}
												
		if (isset($this->request->get['order'])) {
			$url .= '&order=' . $this->request->get['order'];
		}

		$pagination = new Pagination();
		$pagination->total = $headermenu_total;
		$pagination->page = $page;
		$pagination->limit = $this->config->get('config_limit_admin');
		$pagination->text = $this->language->get('text_pagination');
		$pagination->url = $this->url->link('extension/module/custom_menu', 'token=' . $this->session->data['token'] . $url . '&page={page}', 'SSL');
			
		$data['pagination'] = $pagination->render();

		$data['sort'] = $sort;
		$data['order'] = $order;
		
		if (isset($this->request->get['module_id']) && ($this->request->server['REQUEST_METHOD'] != 'POST')) {
			$module_info = $this->model_extension_module->getModule($this->request->get['module_id']);
		}
		
		if (isset($this->request->post['name'])) {
			$data['name'] = $this->request->post['name'];
		} elseif (!empty($module_info)) {
			$data['name'] = $module_info['name'];
		} else {
			$data['name'] = '';
		}
		
		if (isset($this->request->post['status'])) {
			$data['status'] = $this->request->post['status'];
		} elseif (!empty($module_info)) {
			$data['status'] = $module_info['status'];
		} else {
			$data['status'] = '';
		}
		
		$data['custom_menu_module'] = array();
		
		if (isset($this->request->post['custom_menu_module'])) {
			$data['custom_menu_module'] = $this->request->post['custom_menu_module'];
		} elseif (!empty($module_info)) {
			$data['custom_menu_module'] = $module_info['custom_menu_module'];
		}
				
		$data['header'] = $this->load->controller('common/header');
		$data['column_left'] = $this->load->controller('common/column_left');
		$data['footer'] = $this->load->controller('common/footer');

		if (VERSION >= 2.2) {
			$this->response->setOutput($this->load->view('extension/module/custom_menu_list', $data));
		} else {
			$this->response->setOutput($this->load->view('extension/module/custom_menu_list.tpl', $data));
		}
	}

	protected function getForm() {
		
		$data['heading_title'] = $this->language->get('heading_title');

		$data['text_default'] = $this->language->get('text_default');
		$data['text_enabled'] = $this->language->get('text_enabled');
    	$data['text_disabled'] = $this->language->get('text_disabled');
		
		
		$data['entry_description'] = $this->language->get('entry_description');
		$data['entry_store'] = $this->language->get('entry_store');
		$data['entry_keyword'] = $this->language->get('entry_keyword');
		$data['entry_bottom'] = $this->language->get('entry_bottom');
		$data['entry_top'] = $this->language->get('entry_top');
		$data['entry_sort_order'] = $this->language->get('entry_sort_order');
		$data['entry_status'] = $this->language->get('entry_status');
		$data['text_select'] = $this->language->get('text_select');
		
		$data['entry_image'] = $this->language->get('entry_image');
		$data['text_browse'] = $this->language->get('text_browse');
		$data['text_clear'] = $this->language->get('text_clear');
		
		$data['entry_level2'] = $this->language->get('entry_level2');
		$data['entry_title'] = $this->language->get('entry_title');
		$data['entry_link'] = $this->language->get('entry_link');
		$data['entry_parent_id'] = $this->language->get('entry_parent_id');
		$data['text_image_manager'] = $this->language->get('text_image_manager');
		$data['entry_column'] = $this->language->get('entry_column');
		$data['custom_menu'] = $this->model_module_custom_menu->getCustomMenu1();
		
		$data['button_save'] = $this->language->get('button_save');
		$data['button_cancel'] = $this->language->get('button_cancel');
    	
		$data['tab_general'] = $this->language->get('tab_general');
    	$data['tab_data'] = $this->language->get('tab_data');
		$data['tab_design'] = $this->language->get('tab_design');

 		if (isset($this->error['warning'])) {
			$data['error_warning'] = $this->error['warning'];
		} else {
			$data['error_warning'] = '';
		}

 		if (isset($this->error['name'])) {
			$data['error_name'] = $this->error['name'];
		} else {
			$data['error_name'] = array();
		}
		
	 	if (isset($this->error['description'])) {
			$data['error_description'] = $this->error['description'];
		} else {
			$data['error_description'] = array();
		}
		
		$url = '';
			
		if (isset($this->request->get['sort'])) {
			$url .= '&sort=' . $this->request->get['sort'];
		}

		if (isset($this->request->get['order'])) {
			$url .= '&order=' . $this->request->get['order'];
		}
		
		if (isset($this->request->get['page'])) {
			$url .= '&page=' . $this->request->get['page'];
		}
		
  		$data['breadcrumbs'] = array();

   		$data['breadcrumbs'][] = array(
       		'text'      => $this->language->get('text_home'),
			'href'      => $this->url->link('common/home', 'token=' . $this->session->data['token'], 'SSL'),     		
   		);
		
		if(VERSION >= 2.2) {
			$data['breadcrumbs'][] = array(
				'text'      => $this->language->get('text_module'),
				'href'      => $this->url->link('extension/extension', 'token='.$this->session->data['token'].'&type=module', true)
			);
		} else {
			$data['breadcrumbs'][] = array(
				'text'      => $this->language->get('text_module'),
				'href'      => $this->url->link('extension/module', 'token='.$this->session->data['token'], 'SSL')
			);
		}

   		$data['breadcrumbs'][] = array(
       		'text'      => $this->language->get('heading_title'),
			'href'      => $this->url->link('extension/module/custom_menu', 'token=' . $this->session->data['token'] . $url, 'SSL'),
   		);
							
		if (!isset($this->request->get['menu_id'])) {
			$data['action'] = $this->url->link('extension/module/custom_menu/insert', 'token=' . $this->session->data['token'] . $url, 'SSL');
		} else {
			$data['action'] = $this->url->link('extension/module/custom_menu/update', 'token=' . $this->session->data['token'] . '&menu_id=' . $this->request->get['menu_id'] . $url, 'SSL');
		}
		
		$data['cancel'] = $this->url->link('extension/module/custom_menu', 'token=' . $this->session->data['token'] . $url, 'SSL');	
		
		$data['token'] = $this->session->data['token'];
		
		$this->load->model('localisation/language');
		
		$data['languages'] = $this->model_localisation_language->getLanguages();
		$this->language->load('extension/module/custom_menu');

		$this->load->model('setting/store');
		
		$data['stores'] = $this->model_setting_store->getStores();
		
		$this->load->model('tool/image');
		$data['placeholder'] = $this->model_tool_image->resize('no_image.png', 100, 100);
		
		if (isset($this->request->get['menu_id'])) {
			$custom_menu_info=$this->model_module_custom_menu->getCustomMenuForm($this->request->get['menu_id']);
		}	
	
		if (isset($this->request->post['status'])) {
			$data['status'] = $this->request->post['status'];
		} elseif (!empty($custom_menu_info)) {
			$data['status'] = $custom_menu_info['status'];
		} else {
			$data['status'] = 1;
		}	
		
		if (isset($this->request->post['sort_order'])) {
			$data['sort_order'] = $this->request->post['sort_order'];
		} elseif (!empty($custom_menu_info)) {
			$data['sort_order'] = $custom_menu_info['sort_order'];
		} else {
			$data['sort_order'] ='';
		}
				
		if (isset($this->request->post['menu_description'])) {
			$data['menu_description'] = $this->request->post['menu_description'];
		} elseif (isset($this->request->get['menu_id'])) {
			$data['menu_description'] =$this->model_module_custom_menu->getCustomMenuDescriptions($this->request->get['menu_id']);
		} else {
			$data['menu_description'] = array();
		}	
		
		if (isset($this->request->post['link'])) {
			$data['link'] = $this->request->post['link'];
		} elseif (!empty($custom_menu_info)) {
			$data['link'] = $custom_menu_info['link'];
		} else {
			$data['link'] = '';
		}
		
		if (isset($this->request->post['image'])) {
			$data['image'] = $this->request->post['image'];
		} elseif (!empty($custom_menu_info)) {
			$data['image'] = $custom_menu_info['image'];
		} else {
			$data['image'] = '';
		}
		
		$this->load->model('tool/image');

		if (isset($this->request->post['image']) && file_exists(DIR_IMAGE . $this->request->post['image'])) {
			$data['thumb'] = $this->model_tool_image->resize($this->request->post['image'], 100, 100);
		} elseif (!empty($custom_menu_info) && $custom_menu_info['image'] && file_exists(DIR_IMAGE . $custom_menu_info['image'])) {
			$data['thumb'] = $this->model_tool_image->resize($custom_menu_info['image'], 100, 100);
		} else {
			$data['thumb'] = $this->model_tool_image->resize('no_image.jpg', 100, 100);
		}
	
		if (isset($this->request->post['parent_id'])) {
			$data['parent_id'] = $this->request->post['parent_id'];
		} elseif (!empty($custom_menu_info)) {
			$data['parent_id'] = $custom_menu_info['parent_id'];
		} else {
			$data['parent_id'] = '';
		}
		
		if (isset($this->request->post['parent_parent_id'])) {
			$data['parent_parent_id'] = $this->request->post['parent_parent_id'];
		} elseif (!empty($custom_menu_info)) {
			$data['parent_parent_id'] = $custom_menu_info['parent_parent_id'];
		} else {
			$data['parent_parent_id'] = '';
		}
		
		if (isset($this->request->post['column'])) {
			$data['column'] = $this->request->post['column'];
		} elseif (!empty($custom_menu_info)) {
			$data['column'] = $custom_menu_info['column'];
		} else {
			$data['column'] = '';
		}

		$this->load->model('design/layout');
		
		$data['layouts'] = $this->model_design_layout->getLayouts();
		
		$data['header'] = $this->load->controller('common/header');
		$data['column_left'] = $this->load->controller('common/column_left');
		$data['footer'] = $this->load->controller('common/footer');

		if (VERSION >= 2.2) {
			$this->response->setOutput($this->load->view('extension/module/custom_menu_form', $data));
		} else {
			$this->response->setOutput($this->load->view('extension/module/custom_menu_form.tpl', $data));
		}
	}

	protected function validateForm() {
		if (!$this->user->hasPermission('modify', 'extension/module/custom_menu')) {
			$this->error['warning'] = $this->language->get('error_permission');
		}
		
		foreach ($this->request->post['menu_description'] as $language_id => $value) {
			if ((utf8_strlen($value['name']) < 3) || (utf8_strlen($value['name']) > 64)) {
				$this->error['name'][$language_id] = $this->language->get('error_name');
			}
		}
		
		if ($this->error && !isset($this->error['warning'])) {
			$this->error['warning'] = $this->language->get('error_warning');
		}
			
		if (!$this->error) {
			return true;
		} else {
			return false;
		}
	}

	protected function validateDelete() {
		if (!$this->user->hasPermission('modify', 'extension/module/custom_menu')) {
			$this->error['warning'] = $this->language->get('error_permission');
		}

		if (!$this->error) {
			return true;
		} else {
			return false;
		}
	}
}
?>